<div class="wrapper">
    <canvas bind:this={canvasElement} width="250" height="250"/>
</div>

<script>
import { Chart } from '../shared/chart';
import * as colors from '../shared/colors'
import {selectedFruitBasketStore} from '../stores'

let canvasElement
let chart

function initChart() {
    chart = new Chart(canvasElement, {
      type: 'bar',
      data: {
        datasets: [{
          data: [
              $selectedFruitBasketStore.nApples,
              $selectedFruitBasketStore.nOranges
          ],
          backgroundColor: [colors.red, colors.orange],
        }],
        labels: ['Apples', 'Oranges'],
      },
      options: {
        legend: {
          display: false,
        },
        scales: {
          xAxes: [{
            barPercentage: 0.75,
            gridLines: {
              color: colors.lightGray,
            },
          }],
          yAxes: [{
            gridLines: {
              color: colors.lightGray,
              zeroLineColor: colors.lightGray,
            },
            ticks: {
              beginAtZero: true,
              callback: () => '',
              suggestedMax: $selectedFruitBasketStore.nApples + $selectedFruitBasketStore.nOranges,
              suggestedMin: 0,
            }
          }],
        },
      },
    });
}

function updateChart() {
    chart.data.datasets[0].data = [
      $selectedFruitBasketStore.nApples,
      $selectedFruitBasketStore.nOranges,
    ];

    chart.options.scales.yAxes[0].ticks.suggestedMax = $selectedFruitBasketStore.nApples + $selectedFruitBasketStore.nOranges;

    chart.update();
}

function subscriptionUpdated() {
    if (!canvasElement) return;
    if (!chart) {
        initChart()
    } else {
        updateChart()
    }
}

$: {
  $selectedFruitBasketStore
  subscriptionUpdated()
}

</script>

<style lang="scss">
@import '../styles/_variables';

.wrapper {
  background-color: $white;
  border-radius: 0.5rem;
  box-shadow: 1px 1px 3px $gray;
  overflow: hidden;
  padding: 2rem;
  width: 250px;
  height: 250px;
}

canvas {
  pointer-events: none;
}

</style>